=== debian/changelog ===
waifu2x-converter-cpp-dmo (5.3.4-dmo4) unstable; urgency=medium

  * Rebuild for time_t

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 18 Mar 2024 11:59:43 +0100

waifu2x-converter-cpp-dmo (5.3.4-dmo3) unstable; urgency=medium

  * Build with opencv 4.6.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 02 Jul 2022 07:34:55 +0200

waifu2x-converter-cpp-dmo (5.3.4-dmo2) unstable; urgency=medium

  * Build with opencv 4.5d

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 26 Nov 2021 08:44:49 +0100

waifu2x-converter-cpp-dmo (5.3.4-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 27 Jan 2021 08:47:19 +0100

waifu2x-converter-cpp-dmo (5.3.3-dmo3) unstable; urgency=medium

  * Build with opencv 4.5

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 22 Dec 2020 10:08:40 +0100

waifu2x-converter-cpp-dmo (5.3.3-dmo2) unstable; urgency=medium

  * Build with opencv 4.2

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 02 Feb 2020 14:34:55 +0100

waifu2x-converter-cpp-dmo (5.3.3-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 07 Dec 2019 08:56:10 +0100

waifu2x-converter-cpp-dmo (5.3.2-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 05 Dec 2019 14:04:37 +0100

waifu2x-converter-cpp-dmo (5.3.1-dmo2) unstable; urgency=medium

  * Build with opencv 4.1

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 17 Oct 2019 08:52:32 +0200

waifu2x-converter-cpp-dmo (5.3.1-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 13 Jul 2019 23:28:31 +0200

waifu2x-converter-cpp-dmo (5.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 30 Jun 2019 08:37:36 +0200

waifu2x-converter-cpp-dmo (5.2.20180401.git0529f441b7-dmo2) unstable; urgency=medium

  * Disable unneeded ARM optimizations.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 11 Aug 2018 08:51:48 +0200

waifu2x-converter-cpp-dmo (5.2.20180401.git0529f441b7-dmo1) unstable; urgency=medium

  * Package code from DeadSix27 (was from https://github.com/tanakamura)

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 10 Aug 2018 15:38:32 +0200

waifu2x-converter-cpp-dmo (0.0+20171025+gitf89dd6191b-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 22 Dec 2017 10:18:29 +0100
