=== debian/control ===
Source: waifu2x-converter-cpp-dmo
Section: libs
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/DeadSix27/waifu2x-converter-cpp
Rules-Requires-Root: no
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13), cmake, libtclap-dev, opencl-c-headers, quilt,
 libopencv-dev (>= 4.2~), ocl-icd-opencl-dev, ninja-build

Package: libw2xc0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: image super-resolution for anime-style art library
 Image Super-Resolution for Anime-style art using Deep Convolutional Neural
 Networks.
 .
 This package contains the shared libraries.

Package: libw2xc-dev
Section: libdevel
Architecture: any
Depends: libw2xc0 (= ${binary:Version}), ${misc:Depends}
Description: development files for image super-resolution for anime-style art
 Image Super-Resolution for Anime-style art using Deep Convolutional Neural
 Networks.
 .
 This package contains the header files and static libraries which are
 needed for developing GTK+ applications.

#Package: waifu2x-converter
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Description: image super-resolution for anime-style art library
# Image Super-Resolution for Anime-style art using Deep Convolutional Neural
# Networks.
# .
# This package contains the binary.
