=== debian/watch ===
version=4

https://github.com/DeadSix27/waifu2x-converter-cpp/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
